<template>
  <b-carousel controls class="pl-lg-5 pr-lg-5" :interval="0">
    <b-carousel-slide
      v-for="slide in Math.ceil(cards.length / perPage)"
      :key="`slide-${slide}`"
    >
      <template #img>
        <b-card-group deck>
          <div
            v-for="index in perPage"
            :key="`group-${index}`"
            :style="`width: ${Math.floor(100 / perPage)}%`"
          >
            <component
              :is="cardComponent"
              v-if="cards[perPage * (slide - 1) + (index - 1)]"
              :[keyCardComponent]="cards[perPage * (slide - 1) + (index - 1)]"
            ></component>
          </div>
        </b-card-group>
      </template>
    </b-carousel-slide>
  </b-carousel>
</template>
<script>
import { BCarousel, BCarouselSlide, BCardGroup } from 'bootstrap-vue';
export default {
  components: { BCarousel, BCarouselSlide, BCardGroup },
  props: {
    cards: {
      type: Array,
      default() {
        return [];
      },
    },
    perPage: {
      type: Number,
      default: 3,
    },
    cardComponent: {
      type: String,
      default: '',
    },
    keyCardComponent: {
      type: String,
      default: '',
    },
  },
};
</script>
